
; compare two lists
; Samuel Murray, 2019

; 99% of this script is from user mikell on the AutoIt forum:
; https://www.autoitscript.com/forum/topic/164728-compare-2-arrays-with-3-arrays-as-a-result/?do=findComment&comment=1201986

; notes...
; it does not sort entries
; it does, unfortunately, remove duplicate entries
; nt sure if it is case-sensitive

#include <Array.au3>

$f1od = FileOpenDialog ("Select file 1", @ScriptDir, "Text (*.txt)|All file (*.*)", 1)
$f2od = FileOpenDialog ("Select file 2", @ScriptDir, "Text (*.txt)|All file (*.*)", 1)

$f1o = FileOpen ($f1od, 16384)
$f2o = FileOpen ($f2od, 16384)

$f1s = FileOpen ($f1od & "_unique.txt", 33)
$f2s = FileOpen ($f2od & "_unique.txt", 33)
$f3s = FileOpen ("occur in BOTH.txt", 33)

$f1r = FileRead ($f1o)
$f2r = FileRead ($f2o)

$a = StringSplit ($f1r, @CRLF, 1)
$b = StringSplit ($f2r, @CRLF, 1)

Local $sda = ObjCreate("Scripting.Dictionary")
Local $sdb = ObjCreate("Scripting.Dictionary")
Local $sdc = ObjCreate("Scripting.Dictionary")

For $i In $a
    $sda.Item($i) 
Next
For $i In $b
    $sdb.Item($i)
Next

For $i In $a
    If $sdb.Exists($i) Then $sdc.Item($i)
Next
$asd3 = $sdc.Keys() 

For $i In $asd3
    If $sda.Exists($i) Then $sda.Remove($i)
    If $sdb.Exists($i) Then $sdb.Remove($i)
Next
$asd1 = $sda.Keys()
$asd2 = $sdb.Keys()

$file1 = _ArrayToString ($asd1, @CRLF)
$file2 = _ArrayToString ($asd2, @CRLF)
$file3 = _ArrayToString ($asd3, @CRLF)

FileWrite ($f1s, $file1)
FileWrite ($f2s, $file2)
FileWrite ($f3s, $file3)
